# 1 "parse.c"
# 1 "<built-in>" 1
# 1 "<built-in>" 3
# 288 "<built-in>" 3
# 1 "<command line>" 1
# 1 "<built-in>" 2
# 1 "/opt/microchip/xc8/v2.05/pic/include/language_support.h" 1 3
# 2 "<built-in>" 2
# 1 "parse.c" 2





# 1 "./parse.h" 1








# 1 "/opt/microchip/xc8/v2.05/pic/include/c99/inttypes.h" 1 3



# 1 "/opt/microchip/xc8/v2.05/pic/include/c99/musl_xc8.h" 1 3
# 5 "/opt/microchip/xc8/v2.05/pic/include/c99/inttypes.h" 2 3





# 1 "/opt/microchip/xc8/v2.05/pic/include/c99/features.h" 1 3
# 11 "/opt/microchip/xc8/v2.05/pic/include/c99/inttypes.h" 2 3
# 1 "/opt/microchip/xc8/v2.05/pic/include/c99/stdint.h" 1 3
# 22 "/opt/microchip/xc8/v2.05/pic/include/c99/stdint.h" 3
# 1 "/opt/microchip/xc8/v2.05/pic/include/c99/bits/alltypes.h" 1 3
# 135 "/opt/microchip/xc8/v2.05/pic/include/c99/bits/alltypes.h" 3
typedef unsigned long uintptr_t;
# 150 "/opt/microchip/xc8/v2.05/pic/include/c99/bits/alltypes.h" 3
typedef long intptr_t;
# 166 "/opt/microchip/xc8/v2.05/pic/include/c99/bits/alltypes.h" 3
typedef signed char int8_t;




typedef short int16_t;




typedef __int24 int24_t;




typedef long int32_t;





typedef long long int64_t;
# 196 "/opt/microchip/xc8/v2.05/pic/include/c99/bits/alltypes.h" 3
typedef long long intmax_t;





typedef unsigned char uint8_t;




typedef unsigned short uint16_t;




typedef __uint24 uint24_t;




typedef unsigned long uint32_t;





typedef unsigned long long uint64_t;
# 237 "/opt/microchip/xc8/v2.05/pic/include/c99/bits/alltypes.h" 3
typedef unsigned long long uintmax_t;
# 23 "/opt/microchip/xc8/v2.05/pic/include/c99/stdint.h" 2 3

typedef int8_t int_fast8_t;

typedef int64_t int_fast64_t;


typedef int8_t int_least8_t;
typedef int16_t int_least16_t;

typedef int24_t int_least24_t;

typedef int32_t int_least32_t;

typedef int64_t int_least64_t;


typedef uint8_t uint_fast8_t;

typedef uint64_t uint_fast64_t;


typedef uint8_t uint_least8_t;
typedef uint16_t uint_least16_t;

typedef uint24_t uint_least24_t;

typedef uint32_t uint_least32_t;

typedef uint64_t uint_least64_t;
# 155 "/opt/microchip/xc8/v2.05/pic/include/c99/stdint.h" 3
# 1 "/opt/microchip/xc8/v2.05/pic/include/c99/bits/stdint.h" 1 3
typedef int32_t int_fast16_t;
typedef int32_t int_fast32_t;
typedef uint32_t uint_fast16_t;
typedef uint32_t uint_fast32_t;
# 156 "/opt/microchip/xc8/v2.05/pic/include/c99/stdint.h" 2 3
# 12 "/opt/microchip/xc8/v2.05/pic/include/c99/inttypes.h" 2 3




# 1 "/opt/microchip/xc8/v2.05/pic/include/c99/bits/alltypes.h" 1 3
# 17 "/opt/microchip/xc8/v2.05/pic/include/c99/inttypes.h" 2 3

typedef struct { intmax_t quot, rem; } imaxdiv_t;

intmax_t imaxabs(intmax_t);
imaxdiv_t imaxdiv(intmax_t, intmax_t);

intmax_t strtoimax(const char *restrict, char **restrict, int);
uintmax_t strtoumax(const char *restrict, char **restrict, int);
# 10 "./parse.h" 2







typedef char parse_char;

int8_t parse_hex_char(parse_char c);
int8_t parse_dec_char(parse_char c);
int8_t parse_get_numbers(parse_char *buffer,
                         void *buffer_out,
                         uint16_t buffer_out_size,
                         uint16_t *elements_returned,
                         uint8_t int_size,
                         uint8_t radix);
# 7 "parse.c" 2
# 18 "parse.c"
int8_t parse_hex_char(parse_char c)
{
    if ((c >= '0') && (c <= '9'))
    {
        return(c - '0');
    }
    else if ((c >= 'a') && (c <= 'f'))
    {
        return(c - 'a' + 10);
    }
    else if ((c >= 'A') && (c <= 'F'))
    {
        return(c - 'A' + 10);
    }
    else
    {
        return(-1);
    }
}





int8_t parse_dec_char(parse_char c)
{
    if ((c >= '0') && (c <= '9'))
    {
        return(c - '0');
    }
    else
    {
        return(-1);
    }
}





int8_t parse_get_numbers(parse_char *buffer,
                         void *buffer_out,
                         uint16_t buffer_out_size,
                         uint16_t *elements_returned,
                         uint8_t int_size,
                         uint8_t radix)
{
    uint16_t max_elements;

    uint16_t num_idx;
    uint32_t num1;

    uint8_t *p_u8;
    uint32_t *p_u32;

    int8_t digit;


    switch(int_size)
    {
        case 1:
            max_elements = buffer_out_size;
            p_u8 = (uint8_t *) buffer_out;
            break;

        case 4:
            max_elements = buffer_out_size/sizeof(uint32_t);
            p_u32 = (uint32_t *) buffer_out;
            break;

        default:
            return(-1);
    }


    num_idx = 0;


    for ( ; ; )
    {

        if (num_idx >= max_elements) break;


        while ((*buffer==' ') || (*buffer=='\n') || (*buffer=='\r') || (*buffer==',') || (*buffer==':') || (*buffer == '/'))
        {
            buffer++;
        }
        if (*buffer == 0) break;


        num1 = 0;
        switch(radix)
        {
            case 2:
                while ((digit = parse_dec_char(*buffer)) >= 0)
                {
                    num1 = num1*10 + (uint32_t)digit;
                    buffer++;
                }
                break;

            case 1:
                while ((digit = parse_hex_char(*buffer)) >= 0)
                {
                    num1 = (num1 << 4) + (uint32_t)digit;
                    buffer++;
                }
                break;
            default:
                return(-2);
        }


        switch(int_size)
        {
            case 1:
                p_u8[num_idx] = (uint8_t) num1;
                break;

            case 4:
                p_u32[num_idx] = (uint32_t) num1;
                break;
        }
        num_idx++;
    }

    *elements_returned = num_idx;
    return(0);
}
