function [ts] = date_to_ts(month, day, year, hour, min, sec);

% [ts] = date_to_ts(month, day, year, hour, min, sec);
%
% Inputs:
%	month		(1-12)
%	day		(1-31)
%	year		(0-99)
%	hour		(0-23)
%	min		(0-59)
%	sec		(0-59)

ts = sec + 60*(min + 60*(hour + 24*((day-1) + 32*((month-1) + 12*(year)))));


