/*============================================================================
 * eeprom.h
 *      Header file for EEPROM access routines.
 *==========================================================================*/

#ifndef _eeprom_h_
#define _eeprom_h_

void eeprom_init(void);
int8_t eeprom_write_bytes(uint32_t address, uint8_t *data, uint8_t count);
int8_t eeprom_read_bytes(uint32_t address, uint8_t *data, uint8_t count);
void eeprom_sleep(void);

#endif    
