/*============================================================================
 * global.h
 *      Global definitions for RFID reader.
 *==========================================================================*/

#ifndef _global_h_
#define _global_h_

#define HW_VERSION_STRING       "HW_0.9.5"
#define SW_VERSION_STRING       "SW_0.9.5"

#define EEPROM_SIZE_BYTES       262144L

#define EEPROM_CONFIG_BASE       0x0
#define EEPROM_CONFIG_SIZE       0x200

#define EEPROM_LOG_POINTER_BASE  0x200
#define EEPROM_LOG_POINTER_SIZE  0x200

#define EEPROM_LOG_DATA_BASE     0x400
#define EEPROM_LOG_DATA_SIZE     ((uint32_t)EEPROM_SIZE_BYTES - (uint32_t)EEPROM_LOG_DATA_BASE)

#define MAX_ANTENNAS            12
#define MAX_PORTS               12
#define MAX_CACHE_ENTRIES       32

#define GINT_ON                 INTCON |= 0x80
#define GINT_OFF                INTCON &= ~0x80

#endif
