/*============================================================================
 * timer_ms.h
 *	Header for the timer module.
 *==========================================================================*/

#ifndef _timer_ms_h_
#define _timer_ms_h_

#include <inttypes.h>

void timer_ms_init(void);
uint32_t timer_ms_read(void);
uint16_t timer_ms_read_uint16(void);
void timer_ms_delay(uint32_t ms);
inline void timer_ms_isr(void);
void timer_ms_sleep(void);

#endif
